diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/yans-error-rate-model.cc ns-3.44/src/wifi/model/yans-error-rate-model.cc
--- ns-3.43/src/wifi/model/yans-error-rate-model.cc	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/yans-error-rate-model.cc	2025-03-09 16:55:49.807372600 -0700
@@ -38,10 +38,10 @@
 }
 
 double
-YansErrorRateModel::GetBpskBer(double snr, uint32_t signalSpread, uint64_t phyRate) const
+YansErrorRateModel::GetBpskBer(double snr, MHz_u signalSpread, uint64_t phyRate) const
 {
     NS_LOG_FUNCTION(this << snr << signalSpread << phyRate);
-    double EbNo = snr * signalSpread / phyRate;
+    double EbNo = snr * signalSpread * 1e6 / phyRate;
     double z = std::sqrt(EbNo);
     double ber = 0.5 * erfc(z);
     NS_LOG_INFO("bpsk snr=" << snr << " ber=" << ber);
@@ -51,11 +51,11 @@
 double
 YansErrorRateModel::GetQamBer(double snr,
                               unsigned int m,
-                              uint32_t signalSpread,
+                              MHz_u signalSpread,
                               uint64_t phyRate) const
 {
     NS_LOG_FUNCTION(this << snr << m << signalSpread << phyRate);
-    double EbNo = snr * signalSpread / phyRate;
+    double EbNo = snr * signalSpread * 1e6 / phyRate;
     double z = std::sqrt((1.5 * log2(m) * EbNo) / (m - 1.0));
     double z1 = ((1.0 - 1.0 / std::sqrt(m)) * erfc(z));
     double z2 = 1 - std::pow((1 - z1), 2);
@@ -136,7 +136,7 @@
 double
 YansErrorRateModel::GetFecBpskBer(double snr,
                                   uint64_t nbits,
-                                  uint32_t signalSpread,
+                                  MHz_u signalSpread,
                                   uint64_t phyRate,
                                   uint32_t dFree,
                                   uint32_t adFree) const
@@ -157,7 +157,7 @@
 double
 YansErrorRateModel::GetFecQamBer(double snr,
                                  uint64_t nbits,
-                                 uint32_t signalSpread,
+                                 MHz_u signalSpread,
                                  uint64_t phyRate,
                                  uint32_t m,
                                  uint32_t dFree,
@@ -197,8 +197,8 @@
         uint64_t phyRate;
         if ((txVector.IsMu() && (staId == SU_STA_ID)) || (mode != txVector.GetMode(staId)))
         {
-            phyRate = mode.GetPhyRate(txVector.GetChannelWidth() >= 40
-                                          ? 20
+            phyRate = mode.GetPhyRate(txVector.GetChannelWidth() >= MHz_u{40}
+                                          ? MHz_u{20}
                                           : txVector.GetChannelWidth()); // This is the PHY header
         }
         else
@@ -211,19 +211,19 @@
             {
                 return GetFecBpskBer(snr,
                                      nbits,
-                                     txVector.GetChannelWidth() * 1000000, // signal spread
-                                     phyRate,                              // PHY rate
-                                     10,                                   // dFree
-                                     11);                                  // adFree
+                                     txVector.GetChannelWidth(), // signal spread
+                                     phyRate,                    // PHY rate
+                                     10,                         // dFree
+                                     11);                        // adFree
             }
             else
             {
                 return GetFecBpskBer(snr,
                                      nbits,
-                                     txVector.GetChannelWidth() * 1000000, // signal spread
-                                     phyRate,                              // PHY rate
-                                     5,                                    // dFree
-                                     8);                                   // adFree
+                                     txVector.GetChannelWidth(), // signal spread
+                                     phyRate,                    // PHY rate
+                                     5,                          // dFree
+                                     8);                         // adFree
             }
         }
         else if (mode.GetConstellationSize() == 4)
@@ -232,23 +232,23 @@
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    4,                                    // m
-                                    10,                                   // dFree
-                                    11,                                   // adFree
-                                    0);                                   // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    4,                          // m
+                                    10,                         // dFree
+                                    11,                         // adFree
+                                    0);                         // adFreePlusOne
             }
             else
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    4,                                    // m
-                                    5,                                    // dFree
-                                    8,                                    // adFree
-                                    31);                                  // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    4,                          // m
+                                    5,                          // dFree
+                                    8,                          // adFree
+                                    31);                        // adFreePlusOne
             }
         }
         else if (mode.GetConstellationSize() == 16)
@@ -257,23 +257,23 @@
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    16,                                   // m
-                                    10,                                   // dFree
-                                    11,                                   // adFree
-                                    0);                                   // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    16,                         // m
+                                    10,                         // dFree
+                                    11,                         // adFree
+                                    0);                         // adFreePlusOne
             }
             else
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    16,                                   // m
-                                    5,                                    // dFree
-                                    8,                                    // adFree
-                                    31);                                  // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    16,                         // m
+                                    5,                          // dFree
+                                    8,                          // adFree
+                                    31);                        // adFreePlusOne
             }
         }
         else if (mode.GetConstellationSize() == 64)
@@ -282,35 +282,35 @@
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    64,                                   // m
-                                    6,                                    // dFree
-                                    1,                                    // adFree
-                                    16);                                  // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    64,                         // m
+                                    6,                          // dFree
+                                    1,                          // adFree
+                                    16);                        // adFreePlusOne
             }
             if (mode.GetCodeRate() == WIFI_CODE_RATE_5_6)
             {
                 // Table B.32  in Pâl Frenger et al., "Multi-rate Convolutional Codes".
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    64,                                   // m
-                                    4,                                    // dFree
-                                    14,                                   // adFree
-                                    69);                                  // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    64,                         // m
+                                    4,                          // dFree
+                                    14,                         // adFree
+                                    69);                        // adFreePlusOne
             }
             else
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    64,                                   // m
-                                    5,                                    // dFree
-                                    8,                                    // adFree
-                                    31);                                  // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    64,                         // m
+                                    5,                          // dFree
+                                    8,                          // adFree
+                                    31);                        // adFreePlusOne
             }
         }
         else if (mode.GetConstellationSize() == 256)
@@ -319,24 +319,24 @@
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    256,                                  // m
-                                    4,                                    // dFree
-                                    14,                                   // adFree
-                                    69                                    // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    256,                        // m
+                                    4,                          // dFree
+                                    14,                         // adFree
+                                    69                          // adFreePlusOne
                 );
             }
             else
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    256,                                  // m
-                                    5,                                    // dFree
-                                    8,                                    // adFree
-                                    31                                    // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    256,                        // m
+                                    5,                          // dFree
+                                    8,                          // adFree
+                                    31                          // adFreePlusOne
                 );
             }
         }
@@ -346,24 +346,24 @@
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    1024,                                 // m
-                                    4,                                    // dFree
-                                    14,                                   // adFree
-                                    69                                    // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    1024,                       // m
+                                    4,                          // dFree
+                                    14,                         // adFree
+                                    69                          // adFreePlusOne
                 );
             }
             else
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    1024,                                 // m
-                                    5,                                    // dFree
-                                    8,                                    // adFree
-                                    31                                    // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    1024,                       // m
+                                    5,                          // dFree
+                                    8,                          // adFree
+                                    31                          // adFreePlusOne
                 );
             }
         }
@@ -373,24 +373,24 @@
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    4096,                                 // m
-                                    4,                                    // dFree
-                                    14,                                   // adFree
-                                    69                                    // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    4096,                       // m
+                                    4,                          // dFree
+                                    14,                         // adFree
+                                    69                          // adFreePlusOne
                 );
             }
             else
             {
                 return GetFecQamBer(snr,
                                     nbits,
-                                    txVector.GetChannelWidth() * 1000000, // signal spread
-                                    phyRate,                              // PHY rate
-                                    4096,                                 // m
-                                    5,                                    // dFree
-                                    8,                                    // adFree
-                                    31                                    // adFreePlusOne
+                                    txVector.GetChannelWidth(), // signal spread
+                                    phyRate,                    // PHY rate
+                                    4096,                       // m
+                                    5,                          // dFree
+                                    8,                          // adFree
+                                    31                          // adFreePlusOne
                 );
             }
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/yans-error-rate-model.h ns-3.44/src/wifi/model/yans-error-rate-model.h
--- ns-3.43/src/wifi/model/yans-error-rate-model.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/yans-error-rate-model.h	2025-03-09 16:55:49.807372600 -0700
@@ -15,8 +15,8 @@
 {
 
 /**
- * \brief Model the error rate for different modulations.
- * \ingroup wifi
+ * @brief Model the error rate for different modulations.
+ * @ingroup wifi
  *
  * A packet of interest (e.g., a packet can potentially be received by the MAC)
  * is divided into chunks. Each chunk is related to an start/end receiving event.
@@ -43,8 +43,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -61,94 +61,94 @@
     /**
      * Return BER of BPSK with the given parameters.
      *
-     * \param snr SNR ratio (not dB)
-     * \param signalSpread
-     * \param phyRate
+     * @param snr SNR ratio (not dB)
+     * @param signalSpread
+     * @param phyRate
      *
-     * \return BER of BPSK at the given SNR
+     * @return BER of BPSK at the given SNR
      */
-    double GetBpskBer(double snr, uint32_t signalSpread, uint64_t phyRate) const;
+    double GetBpskBer(double snr, MHz_u signalSpread, uint64_t phyRate) const;
     /**
      * Return BER of QAM-m with the given parameters.
      *
-     * \param snr SNR ratio (not dB)
-     * \param m
-     * \param signalSpread
-     * \param phyRate
+     * @param snr SNR ratio (not dB)
+     * @param m
+     * @param signalSpread
+     * @param phyRate
      *
-     * \return BER of BPSK at the given SNR
+     * @return BER of BPSK at the given SNR
      */
-    double GetQamBer(double snr, unsigned int m, uint32_t signalSpread, uint64_t phyRate) const;
+    double GetQamBer(double snr, unsigned int m, MHz_u signalSpread, uint64_t phyRate) const;
     /**
      * Return k!
      *
-     * \param k
+     * @param k
      *
-     * \return k!
+     * @return k!
      */
     uint32_t Factorial(uint32_t k) const;
     /**
      * Return Binomial distribution for a given k, p, and n
      *
-     * \param k
-     * \param p
-     * \param n
+     * @param k
+     * @param p
+     * @param n
      *
-     * \return a Binomial distribution
+     * @return a Binomial distribution
      */
     double Binomial(uint32_t k, double p, uint32_t n) const;
     /**
-     * \param ber
-     * \param d
+     * @param ber
+     * @param d
      *
-     * \return double
+     * @return double
      */
     double CalculatePdOdd(double ber, unsigned int d) const;
     /**
-     * \param ber
-     * \param d
+     * @param ber
+     * @param d
      *
-     * \return double
+     * @return double
      */
     double CalculatePdEven(double ber, unsigned int d) const;
     /**
-     * \param ber
-     * \param d
+     * @param ber
+     * @param d
      *
-     * \return double
+     * @return double
      */
     double CalculatePd(double ber, unsigned int d) const;
     /**
-     * \param snr SNR ratio (not dB)
-     * \param nbits
-     * \param signalSpread
-     * \param phyRate
-     * \param dFree
-     * \param adFree
+     * @param snr SNR ratio (not dB)
+     * @param nbits
+     * @param signalSpread
+     * @param phyRate
+     * @param dFree
+     * @param adFree
      *
-     * \return double
+     * @return double
      */
     double GetFecBpskBer(double snr,
                          uint64_t nbits,
-                         uint32_t signalSpread,
+                         MHz_u signalSpread,
                          uint64_t phyRate,
                          uint32_t dFree,
                          uint32_t adFree) const;
     /**
-     * \param snr SNR ratio (not dB)
-     * \param nbits
-     * \param signalSpread
-     * \param phyRate
-     * \param m
-     * \param dfree
-     * \param adFree
-     * \param adFreePlusOne
+     * @param snr SNR ratio (not dB)
+     * @param nbits
+     * @param signalSpread
+     * @param phyRate
+     * @param m
+     * @param dfree
+     * @param adFree
+     * @param adFreePlusOne
      *
-     * \return double
+     * @return double
      */
     double GetFecQamBer(double snr,
                         uint64_t nbits,
-                        uint32_t signalSpread,
+                        MHz_u signalSpread,
                         uint64_t phyRate,
                         uint32_t m,
                         uint32_t dfree,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/yans-wifi-channel.cc ns-3.44/src/wifi/model/yans-wifi-channel.cc
--- ns-3.43/src/wifi/model/yans-wifi-channel.cc	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/yans-wifi-channel.cc	2025-03-09 16:55:49.807372600 -0700
@@ -93,7 +93,7 @@
 
             auto receiverMobility = (*i)->GetMobility()->GetObject<MobilityModel>();
             const auto delay = m_delay->GetDelay(senderMobility, receiverMobility);
-            const auto rxPower = m_loss->CalcRxPower(txPower, senderMobility, receiverMobility);
+            const dBm_u rxPower{m_loss->CalcRxPower(txPower, senderMobility, receiverMobility)};
             NS_LOG_DEBUG("propagation: txPower="
                          << txPower << "dBm, rxPower=" << rxPower << "dBm, "
                          << "distance=" << senderMobility->GetDistanceFrom(receiverMobility)
@@ -129,13 +129,15 @@
     // Current implementation assumes constant RX power over the PPDU duration
     // Compare received TX power per MHz to normalized RX sensitivity
     const auto txWidth = ppdu->GetTxChannelWidth();
-    if (totalRxPower < phy->GetRxSensitivity() + RatioToDb(txWidth / 20.0))
+    if (totalRxPower < phy->GetRxSensitivity() + RatioToDb(txWidth / MHz_u{20}))
     {
         NS_LOG_INFO("Received signal too weak to process: " << rxPower << " dBm");
         return;
     }
     RxPowerWattPerChannelBand rxPowerW;
-    rxPowerW.insert({{{{0, 0}}, {{0, 0}}}, (DbmToW(totalRxPower))}); // dummy band for YANS
+
+    rxPowerW.insert(
+        {{{{0, 0}}, {{Hz_u{0}, Hz_u{0}}}}, (DbmToW(totalRxPower))}); // dummy band for YANS
     phy->StartReceivePreamble(ppdu, rxPowerW, ppdu->GetTxDuration());
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/yans-wifi-channel.h ns-3.44/src/wifi/model/yans-wifi-channel.h
--- ns-3.43/src/wifi/model/yans-wifi-channel.h	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/yans-wifi-channel.h	2025-03-09 16:55:49.807372600 -0700
@@ -25,8 +25,8 @@
 class WifiPpdu;
 
 /**
- * \brief a channel to interconnect ns3::YansWifiPhy objects.
- * \ingroup wifi
+ * @brief a channel to interconnect ns3::YansWifiPhy objects.
+ * @ingroup wifi
  *
  * This class is expected to be used in tandem with the ns3::YansWifiPhy
  * class and supports an ns3::PropagationLossModel and an
@@ -37,8 +37,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -51,23 +51,23 @@
     /**
      * Adds the given YansWifiPhy to the PHY list
      *
-     * \param phy the YansWifiPhy to be added to the PHY list
+     * @param phy the YansWifiPhy to be added to the PHY list
      */
     void Add(Ptr<YansWifiPhy> phy);
 
     /**
-     * \param loss the new propagation loss model.
+     * @param loss the new propagation loss model.
      */
     void SetPropagationLossModel(const Ptr<PropagationLossModel> loss);
     /**
-     * \param delay the new propagation delay model.
+     * @param delay the new propagation delay model.
      */
     void SetPropagationDelayModel(const Ptr<PropagationDelayModel> delay);
 
     /**
-     * \param sender the PHY object from which the packet is originating.
-     * \param ppdu the PPDU to send
-     * \param txPower the TX power associated to the packet
+     * @param sender the PHY object from which the packet is originating.
+     * @param ppdu the PPDU to send
+     * @param txPower the TX power associated to the packet
      *
      * This method should not be invoked by normal users. It is
      * currently invoked only from YansWifiPhy::StartTx.  The channel
@@ -81,9 +81,9 @@
      * used by this model.  Return the number of streams (possibly zero) that
      * have been assigned.
      *
-     * \param stream first stream index to use
+     * @param stream first stream index to use
      *
-     * \return the number of stream indices assigned by this model
+     * @return the number of stream indices assigned by this model
      */
     int64_t AssignStreams(int64_t stream);
 
@@ -98,9 +98,9 @@
      * The method then calls the corresponding YansWifiPhy that the first
      * bit of the PPDU has arrived.
      *
-     * \param receiver the device to which the packet is destined
-     * \param ppdu the PPDU being sent
-     * \param txPower the TX power associated to the packet being sent
+     * @param receiver the device to which the packet is destined
+     * @param ppdu the PPDU being sent
+     * @param txPower the TX power associated to the packet being sent
      */
     static void Receive(Ptr<YansWifiPhy> receiver, Ptr<const WifiPpdu> ppdu, dBm_u txPower);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/yans-wifi-phy.cc ns-3.44/src/wifi/model/yans-wifi-phy.cc
--- ns-3.43/src/wifi/model/yans-wifi-phy.cc	2024-10-09 16:41:10.132656800 -0700
+++ ns-3.44/src/wifi/model/yans-wifi-phy.cc	2025-03-09 16:55:49.807372600 -0700
@@ -47,7 +47,11 @@
 {
     WifiPhy::SetInterferenceHelper(helper);
     // add dummy band for Yans
-    m_interference->AddBand({{{0, 0}}, {{0, 0}}});
+    m_interference->AddBand({{{0, 0}},
+                             {{
+                                 Hz_u{0},
+                                 Hz_u{0},
+                             }}});
 }
 
 YansWifiPhy::~YansWifiPhy()
@@ -98,20 +102,24 @@
 YansWifiPhy::GetGuardBandwidth(MHz_u currentChannelWidth) const
 {
     NS_ABORT_MSG("Guard bandwidth not relevant for Yans");
-    return 0;
+    return MHz_u{0};
 }
 
 std::tuple<dBr_u, dBr_u, dBr_u>
 YansWifiPhy::GetTxMaskRejectionParams() const
 {
     NS_ABORT_MSG("Tx mask rejection params not relevant for Yans");
-    return std::make_tuple(0.0, 0.0, 0.0);
+    return std::make_tuple(dBr_u{0.0}, dBr_u{0.0}, dBr_u{0.0});
 }
 
 WifiSpectrumBandInfo
 YansWifiPhy::GetBand(MHz_u /*bandWidth*/, uint8_t /*bandIndex*/)
 {
-    return {{{0, 0}}, {{0, 0}}};
+    return {{{0, 0}},
+            {{
+                Hz_u{0},
+                Hz_u{0},
+            }}};
 }
 
 FrequencyRange
@@ -123,7 +131,7 @@
 WifiSpectrumBandFrequencies
 YansWifiPhy::ConvertIndicesToFrequencies(const WifiSpectrumBandIndices& /*indices*/) const
 {
-    return {0, 0};
+    return {Hz_u{0}, Hz_u{0}};
 }
 
 void
